Index: /LMDZ5/trunk/libf/phylmd/phyetat0.F90
===================================================================
--- /LMDZ5/trunk/libf/phylmd/phyetat0.F90	(revision 1937)
+++ /LMDZ5/trunk/libf/phylmd/phyetat0.F90	(revision 1938)
@@ -3,19 +3,22 @@
 SUBROUTINE phyetat0 (fichnom, clesphy0, tabcntr0)
 
-  USE dimphy
-  USE mod_grid_phy_lmdz
-  USE mod_phys_lmdz_para
-  USE iophy
+  USE dimphy, only: klon, zmasq, klev
+  USE iophy, ONLY : init_iophy_new
   USE ocean_cpl_mod,    ONLY : ocean_cpl_init
   USE fonte_neige_mod,  ONLY : fonte_neige_init
   USE pbl_surface_mod,  ONLY : pbl_surface_init
   USE surface_data,     ONLY : type_ocean
-  USE phys_state_var_mod
-  USE iostart
-  USE write_field_phy
-  USE infotrac
+  USE phys_state_var_mod, ONLY : ancien_ok, clwcon, detr_therm, dtime, &
+       du_gwd_rando, dv_gwd_rando, entr_therm, f0, falb1, falb2, fm_therm, &
+       ftsol, pbl_tke, pctsrf, q_ancien, radpas, radsol, rain_fall, ratqs, &
+       rlat, rlon, rnebcon, rugoro, sig1, snow_fall, solaire_etat0, sollw, &
+       solsw, t_ancien, u_ancien, v_ancien, w01, wake_cstar, wake_deltaq, &
+       wake_deltat, wake_fip, wake_pe, wake_s, zgam, zmax0, zmea, zpic, zsig, &
+       zstd, zthe, zval
+  USE iostart, ONLY : close_startphy, get_field, get_var, open_startphy
+  USE infotrac, only: nbtr, type_trac, tname, niadv
   USE traclmdz_mod,    ONLY : traclmdz_from_restart
   USE carbon_cycle_mod, ONLY : carbon_cycle_tr, carbon_cycle_cpl, co2_send
-  USE indice_sol_mod
+  USE indice_sol_mod, only: nbsrf, is_ter, epsfra, is_lic, is_oce, is_sic
 
   IMPLICIT none
@@ -1028,4 +1031,18 @@
   END IF
 
+  if (ok_gwd_rando) then
+     call get_field("du_gwd_rando", du_gwd_rando, found)
+     if (.not. found) then
+        print *, "du_gwd_rando not found, setting it to 0."
+        du_gwd_rando = 0.
+     end if
+
+     call get_field("dv_gwd_rando", dv_gwd_rando, found)
+     if (.not. found) then
+        print *, "dv_gwd_rando not found, setting it to 0."
+        dv_gwd_rando = 0.
+     end if
+  end if
+
   ! on ferme le fichier
   CALL close_startphy
Index: /LMDZ5/trunk/libf/phylmd/phyredem.F90
===================================================================
--- /LMDZ5/trunk/libf/phylmd/phyredem.F90	(revision 1937)
+++ /LMDZ5/trunk/libf/phylmd/phyredem.F90	(revision 1938)
@@ -340,4 +340,13 @@
   END IF
 
+  if (ok_gwd_rando) then
+     call put_field("du_gwd_rando", &
+          "tendency on zonal wind due to gravity waves", &
+          du_gwd_rando)
+     call put_field("dv_gwd_rando", &
+          "tendency on meriodional wind due to gravity waves", &
+          dv_gwd_rando)
+  end if
+
   CALL close_restartphy
   !$OMP BARRIER
Index: /LMDZ5/trunk/libf/phylmd/phys_output_ctrlout_mod.F90
===================================================================
--- /LMDZ5/trunk/libf/phylmd/phys_output_ctrlout_mod.F90	(revision 1937)
+++ /LMDZ5/trunk/libf/phylmd/phys_output_ctrlout_mod.F90	(revision 1938)
@@ -1088,4 +1088,14 @@
     'dthin', 'Hines GWD dT', 'K/s', (/ ('', i=1, 9) /))
 
+  type(ctrl_out), save:: o_du_gwd_rando &
+       = ctrl_out((/ 4, 10, 10, 10, 10, 10, 11, 11, 11 /), 'du_gwd_rando', &
+       "Random gravity waves dU/dt", "m/s2", (/ ('', i=1, 9) /))
+  type(ctrl_out), save:: o_dv_gwd_rando &
+       = ctrl_out((/ 4, 10, 10, 10, 10, 10, 11, 11, 11 /), 'dv_gwd_rando', &
+       "Random gravity waves dV/dt", "m/s2", (/ ('', i=1, 9) /))
+  type(ctrl_out), save:: o_vstr_gwd_rando &
+       = ctrl_out((/ 4, 10, 10, 10, 10, 10, 11, 11, 11 /), 'vstr_gwd_rando', &
+       "meridional wind stress random gravity waves", "Pa", (/ ('', i=1, 9) /))
+
   TYPE(ctrl_out), SAVE, ALLOCATABLE :: o_trac(:)
   TYPE(ctrl_out), SAVE, ALLOCATABLE :: o_trac_cum(:)
Index: /LMDZ5/trunk/libf/phylmd/phys_output_var_mod.F90
===================================================================
--- /LMDZ5/trunk/libf/phylmd/phys_output_var_mod.F90	(revision 1937)
+++ /LMDZ5/trunk/libf/phylmd/phys_output_var_mod.F90	(revision 1938)
@@ -2,59 +2,62 @@
 ! phys_local_var_mod.F90 1327 2010-03-17 15:33:56Z idelkadi $
 
-      MODULE phys_output_var_mod
+MODULE phys_output_var_mod
 
-      use dimphy
-! Variables outputs pour les ecritures des sorties
-!======================================================================
-!
-!
-!======================================================================
-! Declaration des variables
+  use dimphy
+  ! Variables outputs pour les ecritures des sorties
+  !======================================================================
+  !
+  !
+  !======================================================================
+  ! Declaration des variables
 
-      REAL, SAVE, ALLOCATABLE :: snow_o(:), zfra_o(:)
-!$OMP THREADPRIVATE(snow_o, zfra_o)
-      INTEGER, SAVE, ALLOCATABLE ::  itau_con(:)       ! Nombre de pas ou rflag <= 1
-!$OMP THREADPRIVATE(itau_con)
-      REAL, ALLOCATABLE :: bils_ec(:) ! Contribution of energy conservation
-      REAL, ALLOCATABLE :: bils_tke(:) ! Contribution of energy conservation
-      REAL, ALLOCATABLE :: bils_diss(:) ! Contribution of energy conservation
-      REAL, ALLOCATABLE :: bils_kinetic(:) ! bilan de chaleur au sol, kinetic
-      REAL, ALLOCATABLE :: bils_enthalp(:) ! bilan de chaleur au sol
-      REAL, ALLOCATABLE :: bils_latent(:) ! bilan de chaleur au sol
-!$OMP THREADPRIVATE(bils_ec,bils_tke,bils_diss,bils_kinetic,bils_enthalp,bils_latent)
+  REAL, SAVE, ALLOCATABLE :: snow_o(:), zfra_o(:)
+  !$OMP THREADPRIVATE(snow_o, zfra_o)
+  INTEGER, SAVE, ALLOCATABLE ::  itau_con(:)       ! Nombre de pas ou rflag <= 1
+  !$OMP THREADPRIVATE(itau_con)
+  REAL, ALLOCATABLE :: bils_ec(:) ! Contribution of energy conservation
+  REAL, ALLOCATABLE :: bils_tke(:) ! Contribution of energy conservation
+  REAL, ALLOCATABLE :: bils_diss(:) ! Contribution of energy conservation
+  REAL, ALLOCATABLE :: bils_kinetic(:) ! bilan de chaleur au sol, kinetic
+  REAL, ALLOCATABLE :: bils_enthalp(:) ! bilan de chaleur au sol
+  REAL, ALLOCATABLE :: bils_latent(:) ! bilan de chaleur au sol
+  !$OMP THREADPRIVATE(bils_ec,bils_tke,bils_diss,bils_kinetic,bils_enthalp,bils_latent)
 
 
-! ug Plein de variables venues de phys_output_mod
-      INTEGER, PARAMETER                           :: nfiles = 9
-      LOGICAL, DIMENSION(nfiles), SAVE             :: clef_files
-      LOGICAL, DIMENSION(nfiles), SAVE             :: clef_stations
-      INTEGER, DIMENSION(nfiles), SAVE             :: lev_files
-      INTEGER, DIMENSION(nfiles), SAVE             :: nid_files
-      INTEGER, DIMENSION(nfiles), SAVE  :: nnid_files
-!$OMP THREADPRIVATE(clef_files, clef_stations, lev_files,nid_files,nnid_files)
-      INTEGER, DIMENSION(nfiles), SAVE :: nnhorim
+  ! ug Plein de variables venues de phys_output_mod
+  INTEGER, PARAMETER                           :: nfiles = 9
+  LOGICAL, DIMENSION(nfiles), SAVE             :: clef_files
+  LOGICAL, DIMENSION(nfiles), SAVE             :: clef_stations
+  INTEGER, DIMENSION(nfiles), SAVE             :: lev_files
+  INTEGER, DIMENSION(nfiles), SAVE             :: nid_files
+  INTEGER, DIMENSION(nfiles), SAVE  :: nnid_files
+  !$OMP THREADPRIVATE(clef_files, clef_stations, lev_files,nid_files,nnid_files)
+  INTEGER, DIMENSION(nfiles), SAVE :: nnhorim
 
-      INTEGER, DIMENSION(nfiles), SAVE :: nhorim, nvertm
-      INTEGER, DIMENSION(nfiles), SAVE :: nvertap, nvertbp, nvertAlt
-      REAL, DIMENSION(nfiles), SAVE                :: zoutm
-      CHARACTER(LEN=20), DIMENSION(nfiles), SAVE   :: type_ecri
-!$OMP THREADPRIVATE(nnhorim, nhorim, nvertm, zoutm,type_ecri)
-      CHARACTER(LEN=20), DIMENSION(nfiles), SAVE  :: type_ecri_files, phys_out_filetypes
-!$OMP THREADPRIVATE(type_ecri_files, phys_out_filetypes)
-    CHARACTER(LEN=20), DIMENSION(nfiles), SAVE  :: phys_out_filenames
-!$OMP THREADPRIVATE(phys_out_filenames)
+  INTEGER, DIMENSION(nfiles), SAVE :: nhorim, nvertm
+  INTEGER, DIMENSION(nfiles), SAVE :: nvertap, nvertbp, nvertAlt
+  REAL, DIMENSION(nfiles), SAVE                :: zoutm
+  CHARACTER(LEN=20), DIMENSION(nfiles), SAVE   :: type_ecri
+  !$OMP THREADPRIVATE(nnhorim, nhorim, nvertm, zoutm,type_ecri)
+  CHARACTER(LEN=20), DIMENSION(nfiles), SAVE  :: type_ecri_files, phys_out_filetypes
+  !$OMP THREADPRIVATE(type_ecri_files, phys_out_filetypes)
+  CHARACTER(LEN=20), DIMENSION(nfiles), SAVE  :: phys_out_filenames
+  !$OMP THREADPRIVATE(phys_out_filenames)
 
- ! swaero_diag : flag indicates if it is necessary to do calculation for some aerosol diagnostics
-      LOGICAL, SAVE                                :: swaero_diag=.FALSE.
-!$OMP THREADPRIVATE(swaero_diag)
+  ! swaero_diag : flag indicates if it is necessary to do calculation for some aerosol diagnostics
+  LOGICAL, SAVE                                :: swaero_diag=.FALSE.
+  !$OMP THREADPRIVATE(swaero_diag)
 
-      INTEGER, SAVE:: levmin(nfiles) = 1
-      INTEGER, SAVE:: levmax(nfiles)
-!$OMP THREADPRIVATE(levmin, levmax)
+  INTEGER, SAVE:: levmin(nfiles) = 1
+  INTEGER, SAVE:: levmax(nfiles)
+  !$OMP THREADPRIVATE(levmin, levmax)
 
-      REAL, SAVE                :: zdtime_moy
-!$OMP THREADPRIVATE(zdtime_moy)
+  REAL, SAVE                :: zdtime_moy
+  !$OMP THREADPRIVATE(zdtime_moy)
 
-      LOGICAL, SAVE :: vars_defined = .FALSE. ! ug PAS THREADPRIVATE ET C'EST NORMAL
+  LOGICAL, SAVE :: vars_defined = .FALSE. ! ug PAS THREADPRIVATE ET C'EST NORMAL
+
+  REAL, allocatable:: zustr_gwd_rando(:), zvstr_gwd_rando(:) ! (klon)
+  !$OMP THREADPRIVATE(zustr_gwd_rando, zvstr_gwd_rando)
 
   TYPE ctrl_out
@@ -65,27 +68,34 @@
      CHARACTER(len=20),DIMENSION(nfiles)  :: type_ecrit
   END TYPE ctrl_out
+
 CONTAINS
 
-!======================================================================
-SUBROUTINE phys_output_var_init
-use dimphy
+  !======================================================================
+  SUBROUTINE phys_output_var_init
+    use dimphy
 
-IMPLICIT NONE
+    IMPLICIT NONE
 
-      allocate(snow_o(klon), zfra_o(klon))
-      allocate(itau_con(klon))
-      allocate (bils_ec(klon),bils_tke(klon),bils_diss(klon),bils_kinetic(klon),bils_enthalp(klon),bils_latent(klon))
+    include "clesphys.h"
 
-END SUBROUTINE phys_output_var_init
+    !------------------------------------------------
 
-!======================================================================
-SUBROUTINE phys_output_var_end
-use dimphy
-IMPLICIT NONE
+    allocate(snow_o(klon), zfra_o(klon))
+    allocate(itau_con(klon))
+    allocate (bils_ec(klon),bils_tke(klon),bils_diss(klon),bils_kinetic(klon),bils_enthalp(klon),bils_latent(klon))
 
-      deallocate(snow_o,zfra_o,itau_con)
-      deallocate (bils_ec,bils_tke,bils_diss,bils_kinetic,bils_enthalp,bils_latent)
+    IF (ok_gwd_rando) allocate(zustr_gwd_rando(klon), zvstr_gwd_rando(klon))
 
-END SUBROUTINE phys_output_var_end
+  END SUBROUTINE phys_output_var_init
+
+  !======================================================================
+  SUBROUTINE phys_output_var_end
+    use dimphy
+    IMPLICIT NONE
+
+    deallocate(snow_o,zfra_o,itau_con)
+    deallocate (bils_ec,bils_tke,bils_diss,bils_kinetic,bils_enthalp,bils_latent)
+
+  END SUBROUTINE phys_output_var_end
 
 END MODULE phys_output_var_mod
Index: /LMDZ5/trunk/libf/phylmd/phys_output_write_mod.F90
===================================================================
--- /LMDZ5/trunk/libf/phylmd/phys_output_write_mod.F90	(revision 1937)
+++ /LMDZ5/trunk/libf/phylmd/phys_output_write_mod.F90	(revision 1938)
@@ -146,5 +146,6 @@
          o_dtr_insc, o_dtr_bcscav, o_dtr_evapls, &
          o_dtr_ls, o_dtr_trsp, o_dtr_sscav, &
-         o_dtr_sat, o_dtr_uscav, o_trac_cum
+         o_dtr_sat, o_dtr_uscav, o_trac_cum, o_du_gwd_rando, o_dv_gwd_rando, &
+         o_vstr_gwd_rando
 
     USE phys_state_var_mod, only: pctsrf, paire_ter, rain_fall, snow_fall, &
@@ -167,5 +168,5 @@
          vqsumSTD, vTsumSTD, O3daysumSTD, wqsumSTD, &
          vphisumSTD, wTsumSTD, u2sumSTD, v2sumSTD, &
-         T2sumSTD, nlevSTD
+         T2sumSTD, nlevSTD, du_gwd_rando, dv_gwd_rando
 
     USE phys_local_var_mod, only: zxfluxlat, slp, zxtsol, zt2m, &
@@ -216,7 +217,6 @@
 
     USE phys_output_var_mod, only: vars_defined, snow_o, zfra_o, bils_diss, &
-         bils_ec, bils_tke, bils_kinetic, bils_latent, &
-         bils_enthalp, itau_con, nfiles, clef_files, &
-         nid_files
+         bils_ec, bils_tke, bils_kinetic, bils_latent, bils_enthalp, &
+         itau_con, nfiles, clef_files, nid_files, zvstr_gwd_rando
     USE indice_sol_mod, only: nbsrf
     USE infotrac, only: nqtot
@@ -892,11 +892,11 @@
        CALL histwrite_phy(o_rnebcon, rnebcon)
        CALL histwrite_phy(o_rnebls, rneb)
-IF (vars_defined)  THEN
-      DO k=1, klev
-         DO i=1, klon
-            zx_tmp_fi3d(i,k)=cldfra(i,k)*JrNt(i)
-         ENDDO
-      ENDDO
-ENDIF
+       IF (vars_defined)  THEN
+          DO k=1, klev
+             DO i=1, klon
+                zx_tmp_fi3d(i,k)=cldfra(i,k)*JrNt(i)
+             ENDDO
+          ENDDO
+       ENDIF
        CALL histwrite_phy(o_rnebjn, zx_tmp_fi3d)
        CALL histwrite_phy(o_rhum, zx_rh)
@@ -1119,4 +1119,11 @@
           CALL histwrite_phy(o_dthin, zx_tmp_fi3d)
        ENDIF
+
+       IF (ok_gwd_rando) then
+          CALL histwrite_phy(o_du_gwd_rando, du_gwd_rando / pdtphys)
+          CALL histwrite_phy(o_dv_gwd_rando, dv_gwd_rando / pdtphys)
+          CALL histwrite_phy(o_vstr_gwd_rando, zvstr_gwd_rando)
+       end IF
+
        CALL histwrite_phy(o_rsu, swup)
        CALL histwrite_phy(o_rsd, swdn)
Index: /LMDZ5/trunk/libf/phylmd/phys_state_var_mod.F90
===================================================================
--- /LMDZ5/trunk/libf/phylmd/phys_state_var_mod.F90	(revision 1937)
+++ /LMDZ5/trunk/libf/phylmd/phys_state_var_mod.F90	(revision 1938)
@@ -357,4 +357,8 @@
 !!! fin nrlmd le 10/04/2012
 
+      REAL, ALLOCATABLE, SAVE:: du_gwd_rando(:, :), dv_gwd_rando(:, :)
+      !$OMP THREADPRIVATE(du_gwd_rando, dv_gwd_rando)
+      ! tendencies on wind due to gravity waves
+
 CONTAINS
 
@@ -376,4 +380,5 @@
 ! climatology and the daylight climatology
 
+include "clesphys.h"
       ALLOCATE(rlat(klon), rlon(klon))
       ALLOCATE(pctsrf(klon,nbsrf))
@@ -517,4 +522,6 @@
       ALLOCATE(ale_bl_trig(klon))
 !!! fin nrlmd le 10/04/2012
+      if (ok_gwd_rando) allocate(du_gwd_rando(klon, klev), &
+           dv_gwd_rando(klon, klev))
 
 END SUBROUTINE phys_state_var_init
@@ -526,4 +533,5 @@
 USE indice_sol_mod
 IMPLICIT NONE
+include "clesphys.h"
 
       deallocate(rlat, rlon, pctsrf, ftsol, falb1, falb2)
@@ -624,4 +632,5 @@
       deallocate(tau_aero,piz_aero,cg_aero)
       deallocate(ccm)
+      if (ok_gwd_rando) deallocate(du_gwd_rando, dv_gwd_rando)
        
 !!! nrlmd le 10/04/2012
Index: /LMDZ5/trunk/libf/phylmd/physiq.F90
===================================================================
--- /LMDZ5/trunk/libf/phylmd/physiq.F90	(revision 1937)
+++ /LMDZ5/trunk/libf/phylmd/physiq.F90	(revision 1938)
@@ -55,4 +55,6 @@
   !IM stations CFMIP
   USE CFMIP_point_locations
+  use FLOTT_GWD_rando_m, only: FLOTT_GWD_rando
+
   IMPLICIT none
   !>======================================================================
@@ -614,5 +616,5 @@
 
   ! tendance nulles
-  REAL du0(klon,klev),dv0(klon,klev),dq0(klon,klev),dql0(klon,klev)
+  REAL, dimension(klon,klev):: du0, dv0, dt0, dq0, dql0
 
   !
@@ -1390,4 +1392,5 @@
   du0(:,:)=0.
   dv0(:,:)=0.
+  dt0 = 0.
   dq0(:,:)=0.
   dql0(:,:)=0.
@@ -3251,6 +3254,12 @@
   ENDIF
 
-  !
-  !IM cf. FLott BEG
+  if (ok_gwd_rando) then
+     call FLOTT_GWD_rando(DTIME, pplay, t_seri, u_seri, v_seri, &
+          rain_fall + snow_fall, zustr_gwd_rando, zvstr_gwd_rando, &
+          du_gwd_rando, dv_gwd_rando)
+     CALL add_phys_tend(du_gwd_rando, dv_gwd_rando, dt0, dq0, dql0, &
+          'flott_gwd_rando')
+  end if
+
   ! STRESS NECESSAIRES: TOUTE LA PHYSIQUE
 
